
/*******************************************************************************

 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
/*
 * This class is generated using freemarker and the SumZeroAggr.java template.
 */

package org.apache.drill.exec.expr.fn.impl.gaggr;

import org.apache.drill.exec.expr.DrillAggFunc;
import org.apache.drill.exec.expr.annotations.FunctionTemplate;
import org.apache.drill.exec.expr.annotations.FunctionTemplate.FunctionScope;
import org.apache.drill.exec.expr.annotations.Output;
import org.apache.drill.exec.expr.annotations.Param;
import org.apache.drill.exec.expr.annotations.Workspace;
import org.apache.drill.exec.expr.holders.*;

@SuppressWarnings("unused")

public class SumZeroFunctions {
	static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(SumZeroFunctions.class);


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class BitSumZero implements DrillAggFunc{

  @Param BitHolder in;
  @Workspace BitHolder value;
  @Output BitHolder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class IntSumZero implements DrillAggFunc{

  @Param IntHolder in;
  @Workspace BigIntHolder value;
  @Output BigIntHolder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class BigIntSumZero implements DrillAggFunc{

  @Param BigIntHolder in;
  @Workspace BigIntHolder value;
  @Output BigIntHolder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class NullableBitSumZero implements DrillAggFunc{

  @Param NullableBitHolder in;
  @Workspace BitHolder value;
  @Output BitHolder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class NullableIntSumZero implements DrillAggFunc{

  @Param NullableIntHolder in;
  @Workspace BigIntHolder value;
  @Output BigIntHolder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class NullableBigIntSumZero implements DrillAggFunc{

  @Param NullableBigIntHolder in;
  @Workspace BigIntHolder value;
  @Output BigIntHolder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class Float4SumZero implements DrillAggFunc{

  @Param Float4Holder in;
  @Workspace Float8Holder value;
  @Output Float8Holder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class Float8SumZero implements DrillAggFunc{

  @Param Float8Holder in;
  @Workspace Float8Holder value;
  @Output Float8Holder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class NullableFloat4SumZero implements DrillAggFunc{

  @Param NullableFloat4Holder in;
  @Workspace Float8Holder value;
  @Output Float8Holder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }


	@FunctionTemplate(name = "$sum0", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
	public static class NullableFloat8SumZero implements DrillAggFunc{

  @Param NullableFloat8Holder in;
  @Workspace Float8Holder value;
  @Output Float8Holder out;
  
  
  public void setup() {
    value.value = 0;
  }
  
  @Override
  public void add() {
    value.value += in.value;
  }

  @Override
  public void output() {
    out.value = value.value;
  }

  @Override
  public void reset() {
	  value.value = 0;
  }
 
 }

}

